// Functions which emulate needed win32 functions, but aren't in WinCE

#ifdef WINCE

// Multimedia Timers

#define timeGetTime		GetTickCount  

extern void Initialize_MMTimers( void );
extern MMRESULT timeBeginPeriod( UINT uPeriod );
extern MMRESULT timeEndPeriod( UINT uPeriod );
extern MMRESULT timeSetEvent( UINT uDelay, UINT uResolution, LPTIMECALLBACK lpTimeProc, DWORD dwUser, UINT fuEvent);
extern MMRESULT timeKillEvent( UINT uTimerID );

// Win32 unsupported functions

extern DWORD GetCurrentDirectory( DWORD nBufferLength, LPTSTR lpBuffer); 
extern BOOL SetCurrentDirectory( LPCTSTR lpPathName); 

extern void Initialize_GraphFun( void );
extern HDC BeginPaintCE (HWND hwnd, LPPAINTSTRUCT lpPaint);
extern BOOL EndPaintCE(HWND hWnd, CONST PAINTSTRUCT *lpPaint);
extern HDC GetDC_CE(HWND hWnd);
extern int ReleaseDC_CE(HWND hWnd, HDC hDC);

extern BOOL MoveToEx( HDC hdc, int X, int Y, LPPOINT lpPoint); 
extern BOOL LineTo( HDC hdc, int nXEnd, int nYEnd); 

#define	BeginPaint	BeginPaintCE
#define	EndPaint	EndPaintCE
#define GetDC		GetDC_CE
#define ReleaseDC	ReleaseDC_CE


extern HANDLE CreateFileCE(LPCTSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDistribution, DWORD dwFlagsAndAttributes, HANDLE hTemplateFile ); 
extern HANDLE CreateFileForMappingCE(LPCTSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDistribution, DWORD dwFlagsAndAttributes, HANDLE hTemplateFile ); 
extern HANDLE FindFirstFileCE( LPCTSTR lpFileName, LPWIN32_FIND_DATA lpFindFileData ); 

// #define CreateFileCE			CreateFile
// #define CreateFileForMappingCE	CreateFileForMapping

// #define	FindFirstFileCE			FindFirstFile

#define CheckDlgButton(hDlg, idButton, check)	((void)SendMessage(GetDlgItem(hDlg, idButton), BM_SETCHECK, (WPARAM)(int)(check), 0L))
#define IsDlgButtonChecked(hDlg, idButton)		((int)(DWORD)SendMessage(GetDlgItem(hDlg, idButton), BM_GETCHECK, 0L, 0L))
// FILE_MAP_COPY isn't supported in WinCe
#define FILE_MAP_COPY FILE_MAP_READ
// FILE_FLAG_SEQUENTIAL_SCAN isn't supported, either
#ifdef FILE_FLAG_SEQUENTIAL_SCAN
#undef FILE_FLAG_SEQUENTIAL_SCAN
#endif
#define FILE_FLAG_SEQUENTIAL_SCAN FILE_FLAG_RANDOM_ACCESS 

// For SH3 RISC PROCESSORS
// Handling of word alignment problem.

#ifdef SH3

typedef struct _tagBITMAPINFOHEADER {
        UNALIGNED DWORD      biSize;
        UNALIGNED LONG       biWidth;
        UNALIGNED LONG       biHeight;
		UNALIGNED WORD       biPlanes;
        UNALIGNED WORD       biBitCount;
        UNALIGNED DWORD      biCompression;
        UNALIGNED DWORD      biSizeImage;
        UNALIGNED LONG       biXPelsPerMeter;
        UNALIGNED LONG       biYPelsPerMeter;
        UNALIGNED DWORD      biClrUsed;
        UNALIGNED DWORD      biClrImportant;
} UNALIGNED BITMAPINFOHEADER_SH3, FAR *LPBITMAPINFOHEADER_SH3, *PBITMAPINFOHEADER_SH3;

typedef struct _tagBITMAPINFO {
    BITMAPINFOHEADER_SH3	bmiHeader;
    RGBQUAD					bmiColors[1];
} UNALIGNED BITMAPINFO_SH3,FAR *LPBITMAPINFO_SH3, *PBITMAPINFO_SH3;

#define	BITMAPINFOHEADER	BITMAPINFOHEADER_SH3
#define	LPBITMAPINFOHEADER	LPBITMAPINFOHEADER_SH3
#define	PBITMAPINFOHEADER	PBITMAPINFOHEADER_SH3
#define	BITMAPINFO			BITMAPINFO_SH3
#define	LPBITMAPINFO		LPBITMAPINFO_SH3
#define	PBITMAPINFO			PBITMAPINFO_SH3

extern HBITMAP CreateDIBSectionSH3(HDC hdc, const BITMAPINFO_SH3 *pbmi, UINT iUsage, void *ppvBits, HANDLE hSection, DWORD dwOffset);

#define	CreateDIBSection	CreateDIBSectionSH3

#endif // SH3

#endif // WINCE

// Esto es para debug

extern void vprintf( LPCTSTR lpsData );
